Modules/Transisi/Routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::prefix('transisi')->group(function() {
    Route::get('/', 'TransisiController@index');
});

Route::middleware(['auth'])->group(function () {
    // Route::get('employees/company/{id}/pdf', 'EmployeeController@exportPdf')->name('employees.pdf');
    Route::get('employees/company/{id}', 'EmployeeController@filter')->name('employees.filter');
    Route::post('employees/import', 'EmployeeController@importExcel')->name('employees.import_excel');
    Route::resource('employees', EmployeeController::class);
    
    Route::get('companies/export/{id}', 'CompanyController@exportPdf')->name('companies.export.pdf');
    Route::resource('companies', 'CompanyController');
    
    Route::post('companies/get-companies', 'CompanyController@getCompanies')->name('companies.getCompanies');
});

Modules/Transisi/Entities/Employee.php
<?php

namespace Modules\Transisi\Entities;

use Illuminate\Database\Eloquent\Model;

class Employee extends Model
{
    protected $fillable = ['name', 'company_id', 'email', 'status'];
    
    public function company()
    {
        return $this->belongsTo(Company::class);
    }
}

Modules/Transisi/Http/Controllers/Api/EmployeeController.php
<?php

namespace Modules\Transisi\Http\Controllers\Api;

use Illuminate\Http\Request;
use Illuminate\Routing\Controller;
use Illuminate\Contracts\Support\Renderable;
use Modules\Transisi\Repositories\EmployeeRepository;
use Modules\Transisi\Http\Requests\EmployeeStoreRequest;
use Modules\Transisi\Http\Requests\EmployeeUpdateRequest;

class EmployeeController extends Controller
{
    public function __construct(EmployeeRepository $employee)
    {
        $this->employee = $employee;
    }

    /**
     * Display a listing of the resource.
     * @return Renderable
     */
    public function index(Request $request)
    {
        $employees = $this->employee->fetch($request->all());
        return response()->json([
            'success' => TRUE,
            'data' => $employees
        ], 200);
    }

    /**
     * Store a newly created resource in storage.
     * @param Request $request
     * @return Renderable
     */
    public function store(EmployeeStoreRequest $request)
    {
        try {
            $collection = $request->except(['_token','_method']);
            $employee = $this->employee->store($collection);
    
            if ($employee) {
                return response()->json([
                    'success'=> TRUE, 
                    'message'=> 'The employee has been created successfully.', 
                    'data'=> $collection
                ]);
            }
        } catch (\Exception $e) {
            return response()->json([
                'success'=> FALSE, 
                'message'=> $e->getMessage()
            ], 500);
        }       
    }

    /**
     * Show the specified resource.
     * @param int $id
     * @return Renderable
     */
    public function show($id)
    {
        try {
            $employee = $this->employee->find($id);

            if ($employee) {
                return response()->json([
                    'success'=> TRUE, 
                    'data'=> $employee
                ]);
            } else {
                return response()->json([
                    'success'=> FALSE, 
                    'message'=> 'Employee ID not found' 
                ], 404);
            }
        } catch (\Exception $e) {
            return response()->json([
                'success'=> FALSE, 
                'message'=> $e->getMessage()
            ], 500);
        }
    }

    /**
     * Update the specified resource in storage.
     * @param Request $request
     * @param int $id
     * @return Renderable
     */
    public function update(EmployeeUpdateRequest $request, $id)
    {
        try {
            $collection = $request->except(['_token','_method']);
            $this->employee->update($id, $collection);
    
            return response()->json([
                'success'=> TRUE, 
                'message'=> 'The Employee has been updated successfully.', 
                'data'=> $collection
            ]);
        } catch (\Exception $e) {
            return response()->json([
                'success'=> FALSE, 
                'message'=> $e->getMessage()
            ], 500);
        }
    }

    /**
     * Remove the specified resource from storage.
     * @param int $id
     * @return Renderable
     */
    public function destroy($id)
    {
        try {
            $employee = $this->employee->find($id);
            if ($employee) {
                $this->employee->destroy($id);
                return response([
                    'success'=> TRUE, 
                    'message'=> 'The employee has been deleted successfully.', 
                ]);
            }else {
                return response([
                    'success'=> FALSE, 
                    'message'=> 'Employee not found.', 
                ], 404);
            }
        } catch (\Exception $e) {
            return response()->json([
                'success'=> FALSE, 
                'message'=> $e->getMessage()
            ], 500);
        }

    }
}

Modules/Transisi/Http/Controllers/EmployeeController.php
<?php

namespace Modules\Transisi\Http\Controllers;

use Illuminate\Http\Request;
use Illuminate\Routing\Controller;
use Modules\Transisi\Constants\Status;
use Illuminate\Contracts\Support\Renderable;
use Modules\Transisi\Imports\EmployeeImport;
use Maatwebsite\Excel\Facades\Excel as Excel;
use Modules\Transisi\Repositories\CompanyRepository;
use Modules\Transisi\Repositories\EmployeeRepository;
use Modules\Transisi\Http\Requests\ImportExcelRequest;

class EmployeeController extends Controller
{
    public function __construct(CompanyRepository $company, EmployeeRepository $employee)
    {
        $this->employee = $employee;
        $this->company = $company;
    }
    
    /**
     * Display a listing of the resource.
     * @return Renderable
     */
    public function index(Request $request)
    {
        $companies = $this->company->all();
        $employees = $this->employee->fetch($request->all());

        return view('transisi::employees.index', compact('companies','employees'));
    }

    /**
     * Show the form for creating a new resource.
     * @return Renderable
     */
    public function create()
    {
        return view('transisi::employees.create');
    }

    /**
     * Store a newly created resource in storage.
     * @param Request $request
     * @return Renderable
     */
    public function store(Request $request)
    {
        //
    }

    /**
     * Show the specified resource.
     * @param int $id
     * @return Renderable
     */
    public function show($id)
    {
        return view('transisi::show');
    }

    /**
     * Show the form for editing the specified resource.
     * @param int $id
     * @return Renderable
     */
    public function edit($id)
    {
        return view('transisi::edit');
    }

    /**
     * Update the specified resource in storage.
     * @param Request $request
     * @param int $id
     * @return Renderable
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     * @param int $id
     * @return Renderable
     */
    public function destroy($id)
    {
        $this->employee->destroy($id);

        return redirect()->route('employees.index')->with('success', 'Hapus data Berhasil');
    }

    public function importExcel(ImportExcelRequest $request) 
	{
        $file = $request->file('file');
        
        $fileName = time().$file->getClientOriginalName();
		$file->move('employee',$fileName);

		$import =  Excel::import(new EmployeeImport, public_path('/employee/'.$fileName));
 
		return redirect()->route('employees.index');
	}
}

Modules/Transisi/Resources/views/employees/create.blade.php
@extends('transisi::layouts.master')
@section('content')
<div class="container">

<!-- For defining autocomplete -->

  <div class="card">
    <div class="card-header">
      Tambah Employee
    </div>
    <div class="card-body">

      <form action="{{ route('employees.store') }}" method="post">@csrf
        <div class="form-group">
          <label for="name">Nama</label>
          <input type="text" class="form-control" name="name" value="{{ old('name') }}">
          @error('name')
          <span class="text-danger">
          {{ $errors->first('name') }}
          </span>
          @enderror
        </div>

        <!-- select2 -->
        <div class="form-group">
          <label for="exampleFormControlSelect2">Company</label>
          <select id="selectCompany" class="form-control" name="company_id">
            <option selected disabled>-- Pilih --</option>
          </select>
          @error('company_id')
          <span class="text-danger">
          {{ $errors->first('company_id') }}
          </span>
          @enderror
        </div>
        <!-- / select -->

        <div class="form-group">
          <label for="email">Email</label>
          <input type="email" class="form-control" name="email" value="{{ old('email') }}">
          @error('email')
          <span class="text-danger">
          {{ $errors->first('email') }}
          </span>
          @enderror
        </div>

        <button type="submit" class="btn btn-primary">Submit</button>
      </form>
    </div>
  </div>
</div>
@push('scripts')
 <!-- Script -->
 <script type="text/javascript">
  let CSRF_TOKEN = "{{ csrf_token() }}"; 
  $(document).ready(function(){

    $("#selectCompany").select2({
      ajax: { 
        url: "{{ route('companies.getCompanies') }}",
        type: "post",
        dataType: 'json',
        delay: 250,
        data: function (params) {
          return {
            _token: CSRF_TOKEN,
            search: params.term // search term
          };
        },
        processResults: function (response) {
          return {
            results: response
          };
        },
        cache: true
      }

    });

  });
</script>
@endpush
@endsection

Modules/Transisi/Resources/views/employees/edit.blade.php
@extends('transisi::layouts.master')
@section('content')
<div class="container">

<!-- For defining autocomplete -->

  <div class="card">
    <div class="card-header">
      Tambah Employee
    </div>
    <div class="card-body">

      <form action="{{ route('employees.update', $employee) }}" method="post">@csrf @method('put')
        <div class="form-group">
          <label for="name">Nama</label>
          <input type="text" class="form-control" name="name" value="{{ $employee->name }}">
          @error('name')
          <span class="text-danger">
          {{ $errors->first('name') }}
          </span>
          @enderror
        </div>

        <!-- select2 -->
        <div class="form-group">
          <label for="exampleFormControlSelect2">Company</label>
          <select id="selectCompany" class="form-control" name="company_id">
            <option selected disabled>-- Pilih --</option>
          </select>
          @error('company_id')
          <span class="text-danger">
          {{ $errors->first('company_id') }}
          </span>
          @enderror
        </div>
        <!-- / select -->

        <div class="form-group">
          <label for="email">Email</label>
          <input type="email" class="form-control" name="email" value="{{$employee->email }}">
          @error('email')
          <span class="text-danger">
          {{ $errors->first('email') }}
          </span>
          @enderror
        </div>

        <button type="submit" class="btn btn-primary">Submit</button>
      </form>
    </div>
  </div>
</div>
@push('scripts')
 <!-- Script -->
 <script type="text/javascript">
  let CSRF_TOKEN = "{{ csrf_token() }}"; 
  $(document).ready(function(){

    $("#selectCompany").select2({
      ajax: { 
        url: "{{ route('companies.getCompanies') }}",
        type: "post",
        dataType: 'json',
        delay: 250,
        data: function (params) {
          return {
            _token: CSRF_TOKEN,
            search: params.term, // search term
          };
        },
        processResults: function (response) {
          return {
            results: response,
          };
        },
        cache: true
      }

    });

  });
</script>
@endpush
@endsection

Modules/Transisi/Resources/views/employees/index.blade.php
@extends('transisi::layouts.master')
@section('content')

@php
  use Modules\Transisi\Constants\Status;
@endphp

<div class="container">
@if(Session::has('success'))
  <div class="alert alert-success">
      {{ Session::get('success') }}
      @php
          Session::forget('success');
      @endphp
  </div>
@endif
@if(Session::has('error'))
  <div class="alert alert-danger">
      {{ Session::get('error') }}
      @php
          Session::forget('error');
      @endphp
  </div>
@endif
  <div class="card">
    <div class="card-header">
      Data Employee
    </div>
    <div class="card-body">
    <div class="dropdown">
      <button class="btn btn-secondary btn-sm dropdown-toggle" type="button" id="dropdownMenuButton" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
        Filter Company
      </button>
      <div class="dropdown-menu" aria-labelledby="dropdownMenuButton">
      @foreach($companies as $company)
        <a class="dropdown-item" href="{{ route('employees.filter', $company->id) }}">{{ $company->name }}</a>
      @endforeach
      {{$companies->links()}}
      </div>
    </div>
    

      <div class="d-flex justify-content-end">
        <div class="dropdown">
          <button class="btn btn-secondary btn-sm dropdown-toggle mr-2" type="button" id="dropdownMenuButton" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
            Filter Employee
          </button>
          <div class="dropdown-menu" aria-labelledby="dropdownMenuButton">
            <a class="dropdown-item" href="{{ route('employees.index', 'status=1') }}">Aktif</a>
            <a class="dropdown-item" href="{{ route('employees.index', 'status=2') }}">Tidak Aktif</a>
            <a class="dropdown-item" href="{{ route('employees.index', 'status=3') }}">Diblok</a>
          </div>
        </div>
        <a href="{{ route('employees.create') }}" class="btn btn-primary btn-sm my-2 pull-right">Tambah Employee</a>
        <button type="button" class="btn btn-sm btn-success my-2 ml-2 mb-2" data-bs-toggle="modal" data-bs-target="#importExcel">
          Import Excel
        </button>
      </div>
      <div class="table-responsive">
        <table class="table table-hover">
          <thead>
            <tr>
              <th scope="col">No</th>
              <th scope="col">Nama</th>
              <th scope="col">Company</th>
              <th scope="col">Email</th>
              <th scope="col">Status</th>
              <th scope="col">Aksi</th>
            </tr>
          </thead>
          <tbody>
            @foreach($employees as $employee)
            <tr>
              <th>{{ $loop->iteration }}</th>
              <td>{{ $employee->name }}</td>
              <td>{{ $employee->company->name }}</td>
              <td>{{ $employee->email }}</td>
              <td>{{Status::label($employee->status)}}</td>
              <td>
                <a href="{{ route('employees.edit', $employee) }}" class="btn btn-sm btn-warning">Edit</a>
                <form action="{{ route('employees.destroy', $employee) }}" method="post" style="display:inline">
                @csrf @method('DELETE')
                  <button class="btn btn-danger btn-sm" type="submit">Hapus</button>
                </form>
              </td>
            </tr>
            @endforeach
          </tbody>
        </table>
      </div>
      {{ $employees->links() }}
    </div>
  </div>
</div>

<!-- Modal -->
<div class="modal fade" id="importExcel" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
			<div class="modal-dialog" role="document">
				<form method="post" action="{{ route('employees.import_excel') }}" enctype="multipart/form-data">
					<div class="modal-content">
						<div class="modal-header">
							<h5 class="modal-title" id="exampleModalLabel">Import Excel</h5>
						</div>
						<div class="modal-body">
 
							{{ csrf_field() }}
 
							<label>Pilih file excel</label>
							<div class="form-group">
								<input type="file" name="file">
                @error('file')
                <span class="text-danger">
                {{ $errors->first('file') }}
                </span>
                @enderror
							</div>
 
						</div>
						<div class="modal-footer">
							<button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
							<button type="submit" class="btn btn-primary">Import</button>
						</div>
					</div>
				</form>
			</div>
		</div>
@endsection